<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Users_model extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
    }
    
    public function create()
    {
        if(empty($_POST)) {
            return array('status' => 0, 'msg' => 'Sorry! We did not receive anything!!');
        }
        
        $username = $this->input->post('user_name');
        $row = get_row_data('tbl_users', 'user_name', $username);
        
        if(!empty($row)) return array('status' => 0, 'msg' => 'Username already taken. Please choose another one!');
        
        $data = array(
                    'user_fullname' => $this->input->post('full_name'),
                    'user_name' => $username,
                    'user_phone' => $this->input->post('phone'),
                    'user_email' => $this->input->post('email'),
                    'user_password' => md5($this->input->post('password')),
                    'user_level' => $this->input->post('level'),
                    'user_permissions' => $this->input->post('permissions'),
                    'user_creator' => $this->session->userdata('user_id'),
                    'user_createdate' => date('Y-m-d H:i:s')
                );
        if($this->db->insert('tbl_users', $data)) return array('status' => 1, 'msg' => 'User created successfully!');
        
        else return array('status' => 0, 'msg' => 'Error! User couldnot be created! Please try again later!');
    }
    
    public function update()
    {
        if(empty($_POST)) {
            return array('status' => 0, 'msg' => 'Sorry! We did not receive anything!!');
        }
        
        $data = array(
                    'user_fullname' => $this->input->post('full_name'),
                    'user_phone' => $this->input->post('phone'),
                    'user_email' => $this->input->post('email'),
                    'user_password' => md5($this->input->post('password')),
                    'user_level' => $this->input->post('level'),
                    'user_permissions' => $this->input->post('permissions'),
                    'user_updator' => $this->session->userdata('user_id')
                );
        if($this->db->update('tbl_users', $data)) return array('status' => 1, 'msg' => 'User updated successfully!');
        
        else return array('status' => 0, 'msg' => 'Error! User couldnot be updated! Please try again later!');
    }
    
    public function login()
    {
        if(empty($_POST)) {
            return array('status' => 0, 'msg' => 'Sorry! We did not receive anything!!');
        }
        
        $username = $this->input->post('user_name');
        $password = $this->input->post('password');
        
        $query = $this->db->get_where('tbl_users', array('user_username' => $username, 'user_password' => md5($password)));
        
        if($query->num_rows() == 0) return array('status' => 0, 'msg' => 'Username and password do not match! Please tyr again!');
        
        $result = $query->row_array();
        
        $this->session->set_userdata(array('user_id' => $result['user_id']));
        
        return array('status' => 1, 'msg' => 'Login successful!');
    }
  
    public function respond()
    {
        if(empty($_POST)) {
            return array('status' => 0, 'msg' => 'Sorry! We did not receive anything!!');
        }
        $resp_id = $this->input->post('reason_id');
        $comments = $this->input->post('comments');
        $reason = $this->input->post('reason');
        $data = array(
          'resp_reason' => $reason,
          'resp_reason_id' => $resp_id,
          'resp_comments' => $comments,
          'resp_creator' => $this->session->userdata('user_id'),
          'resp_createdate' => date('Y-m-d H:i:s'),
        );
      
       if($this->db->insert('tbl_responses', $data)){
          $my_email = get_that_data('tbl_users', 'user_id', $this->session->userdata('user_id'), 'user_email');
          switch($reason) {
            case 'branding' : 
                $row = $this->db->query("SELECT user_email, block_manageremail, block_brandingemails, block_marketingemails FROM tbl_branding JOIN tbl_visits ON visit_id = branding_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE branding_id = $resp_id")->row_array();
                $to = array('gurdeep.kaur@crownpaints.co.ke', 'nicholas.morwabe@crownpaints.co.ke', $row['user_email'], $row['block_manageremail'], $row['block_brandingemails'], $row['block_marketingemails'], $my_email);
            break;
            
            case 'marketing' :
                $row = $this->db->query("SELECT user_email, block_manageremail, block_brandingemails, block_marketingemails FROM tbl_marketing JOIN tbl_visits ON visit_id = marketing_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE marketing_id = $resp_id")->row_array();
                $to = array('gurdeep.kaur@crownpaints.co.ke', 'nicholas.morwabe@crownpaints.co.ke', $row['user_email'], $row['block_manageremail'], $row['block_brandingemails'], $row['block_marketingemails'], $my_email);
            break;
            
            case 'pc' : 
                $row = $this->db->query("SELECT user_email, block_manageremail, block_brandingemails, block_marketingemails FROM tbl_productcomplains JOIN tbl_visits ON visit_id = pc_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE pc_id = $resp_id")->row_array();
                $to = array('talk2us@crownpaints.co.ke', 'omondi.ian@crownpaints.co.ke', 'nileshsgosavi@crownpaints.co.ke', $row['user_email'], $row['block_manageremail'], 'sandile.shoko@crownpaints.co.ke', $my_email);
            break;
            
            case 'other' : 
                $row = $this->db->query("SELECT user_email, block_manageremail FROM tbl_others JOIN tbl_visits ON visit_id = other_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE other_id = $resp_id")->row_array();
                $to = array($row['user_email'], $row['block_manageremail'], $my_email);
            break;
            
            case 'compe' : 
                $row = $this->db->query("SELECT user_email, block_manageremail FROM tbl_compeinfo JOIN tbl_visits ON visit_id = ci_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE ci_id = $resp_id")->row_array();
                $to = array($row['user_email'], $row['block_manageremail'], 'bhavesh.gandhi@crownpaints.co.ke', $my_email);
            break;
            
            case 'du' : 
                $row = $this->db->query("SELECT user_fullname, user_email, block_manageremail, block_adminemail, block_ITemails FROM tbl_duissues JOIN tbl_visits ON visit_id = du_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE du_id = $resp_id")->row_array();
                $to = array('otieno.eliazar@crownpaints.co.ke', 'talk2us@crownpaints.co.ke', $row['user_email'], $row['block_manageremail'], $row['block_adminemail'], $row['block_ITemails'], $my_email);
            break;
            
            case 'training' : 
                $row = $this->db->query("SELECT user_fullname, user_email, block_manageremail, block_trainingemail FROM tbl_trainings JOIN tbl_visits ON visit_id = training_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE training_id = $resp_id")->row_array();
                $to = array('george.opudo@crownpaints.co.ke', $row['block_trainingemail'], $row['user_email'], $row['block_manageremail'], $my_email);
            break;
            
            case 'lpo' : 
                $row = $this->db->query("SELECT user_fullname, user_email, block_manageremail, block_ccareemail FROM tbl_trainings JOIN tbl_visits ON visit_id = training_visitid JOIN tbl_users ON user_id = visit_userId JOIN tbl_blocks ON block_id = user_fieldId WHERE training_id = $resp_id")->row_array();
                $to = array($row['user_email'], $row['block_manageremail'], $row['block_ccareemail'], $my_email);
            break;
            
            default :
                $to = array($my_email);
            break;
            
          }
         
         sendMail($to, 'Issue Reponse', $comments);
          return array('status' => 1, 'msg' => 'Response saved successful! '.$resp_id);
       }
       else return array('status' => 0, 'msg' => 'Response could not be saved!');
    }
}
